include database.e
include msgbox.e

global constant DB_NEXT = 1
global constant DB_PREV = -1
global sequence DB_INDEX_LIST, DB_INDEX_POINTER
DB_INDEX_LIST = {} DB_INDEX_POINTER = {}

integer OP_OK, OP_ERROR, void
OP_OK = 1  OP_ERROR = -9 

global function DB_Open(sequence db, integer mode, integer tries, integer hasindex)
integer rvalue, loopval, dbx
object crap 
	loopval = 1
	while 1 do
		rvalue = db_open(db, mode)
		if rvalue = DB_OK then
			if hasindex = 1 then
				dbx = open(db & ".edx", mode) 
				if dbx != -1 then
					while 1 do
						crap = get(dbx)
						if atom(crap) = 0 then
							DB_INDEX_LIST = append(DB_INDEX_LIST, crap)
							DB_INDEX_POINTER = append(DB_INDEX_POINTER, "1")
						end if
					end while
					close(dbx)
				else
					void = dos_message_box("Error Opening Index File " & db & ".dbx", "File Open Error", MB_YESNO)
					return OP_ERROR
				end if
			end if
			return OP_OK		
		end if
		if rvalue = DB_OPEN_FAIL or rvalue = DB_LOCK_FAIL or rvalue = DB_LOCK_SHARED then
			loopval += 1
			if loopval >= tries then
				exit
			end if
			sleep(5)
		end if
	end while
	if rvalue = DB_OPEN_FAIL then
		void = dos_message_box("Error Opening Database " & db, "File Open Error", MB_YESNO)
	elsif rvalue = DB_LOCK_FAIL then
		void = message_box("Error Locking Database " & db, "File Lock Error", MB_OK)
	elsif rvalue = DB_LOCK_SHARED then
		void = message_box("Error Sharing Database " & db, "File Share Error", MB_OK)
	end if
	return rvalue
end function

global function DB_Close(sequence db)
	if db_select(db) != DB_OK then
		void =message_box("Error Selecting Database " & db, "File Close Error", MB_OK)
	   	return OP_ERROR
	end if
	db_close()
	return OP_OK
end function

global function DB_GetRecord(sequence db, sequence table, integer recnum)
object data
	if db_select(db) != DB_OK then
    	void =message_box("Error Accessing Database " & db, "Get Record Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Accessing Table " & db & "->" & table, "Get Record Error", MB_OK)
		return OP_ERROR	    
	end if
	if recnum > db_table_size() then
		void =message_box("Record Number Out of Range" & db & "->" & table & "->" & sprintf("%d", recnum), "Get Record Error", MB_OK)
		return OP_ERROR
	end if
	data = db_record_data(recnum) 
	return data
end function

global function DB_PutRecord(sequence db, sequence table, integer recnum, sequence data)
	if db_select(db) != DB_OK then
    	void =message_box("Error Accessing Database " & db, "Put Record Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Accessing Table " & db & "->" & table,"Put Record Error", MB_OK)
		return OP_ERROR
	end if
	if recnum > db_table_size() then
		void =message_box("Record Number Out of Range" & db & "->" & table & "->" & sprintf("%d", recnum), "Put Record Error", MB_OK)
		return OP_ERROR
	end if
	db_replace_data(recnum, data)
	return OP_OK
end function

global function DB_Append(sequence db, sequence table, object key, sequence data)
	if db_select(db) != DB_OK then
    	void =message_box("Error Accessing Database " & db, "Append Record Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Accessing Table " & db & "->" & table, "Append Record Error", MB_OK)
		return OP_ERROR
	end if
	if db_insert(key, data) = DB_EXISTS_ALREADY then
    	void =message_box("Key Already Exists " & db & "->" & table, "Append Record Error", MB_OK)
		return OP_ERROR
	end if
	return OP_OK
end function

global function DB_Select(sequence db, sequence table)
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Select Table Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Selecting Table " & db & "->" & table,"Select Table Error", MB_OK)
		return OP_ERROR	    
	end if
	return OP_OK
end function

global function DB_NumRecs(sequence db, sequence table)
integer rvalue
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Record Count Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Selecting Table " & db & "->" & table,"Record Count Error", MB_OK)
		return OP_ERROR	    
	end if
	rvalue = db_table_size()
	return rvalue
end function

global function DB_DelRec(sequence db, sequence table, integer recnum)
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Delete Record Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Selecting Table " & db & "->" & table,"Delete Record Error", MB_OK)
		return OP_ERROR
	end if
	if recnum > db_table_size() then
		void =message_box("Record Number Out of Range" & db & "->" & table &"->" & sprintf("%d",recnum), "Delete Record Error", MB_OK)
		return OP_ERROR
	end if
	db_delete_record(recnum)
	return OP_OK
end function

global function DB_ZAP(sequence db, sequence table)
integer numrecs
	
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Zap Table Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Selecting Table " & db & "->" & table,"Zap Table Error", MB_OK)
		return OP_ERROR
	end if
	void =message_box("This will delete all records, ARE YOU SURE!?!?", "Zap Table Warning", {MB_YESNO, MB_DEFBUTTON2})
		if void = 1 then
			return OP_ERROR
		end if
	numrecs = db_table_size()
	if numrecs > 0 then
		for x = 1 to numrecs do
			db_delete_record(x)
		end for
		void = db_compress()
	end if
	return OP_OK
end function

global function DB_Seek(sequence db, sequence table, object key)
integer recnum
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Seek Record Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Selecting Table " & db & "->" & table,"Seek Record Error", MB_OK)
		return OP_ERROR	    
	end if
	recnum = db_find_key(key)
	if recnum < 0 then
		recnum = 0
	end if
	return recnum
end function

global function DB_CopyRec(sequence db, sequence table, integer recnum)
object data
sequence newkey

	newkey = ""
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Copy Record Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Selecting Table " & db & "->" & table,"Copy Record Error", MB_OK)
		return OP_ERROR	    
	end if
	if recnum > db_table_size() then
		void =message_box("Record Number Out of Range" & db & "->" & table &"->" & sprintf("%d",recnum), "Copy Record Error", MB_OK)
		return OP_ERROR	    
	end if
	data = db_record_data(recnum)
	newkey = "**********" 
	if db_insert(void, data) != DB_OK then
    	void =message_box("Error Appending Record " & db & "->" & table,"Copy Record Error", MB_OK)
		return OP_ERROR
	end if
	recnum = db_find_key(newkey)
	return recnum
end function

global function DB_GetKey(sequence db, sequence table, integer recnum)
object key
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Get Key Error", MB_OK)
		return OP_ERROR
	end if
	if db_select_table(table) != DB_OK then
    	void =message_box("Error Selecting Table " & db & "->" & table,"Get Key Error", MB_OK)
		return OP_ERROR	    
	end if
	if recnum > db_table_size() then
		void =message_box("Record Number Out of Range " & db & "->" & table & "->" & sprintf("%d",recnum), "Get Key Error", MB_OK)
		return OP_ERROR	    
	end if
	key = db_record_key(recnum)
	return key
end function

global function DB_TableList(sequence db)
sequence tables
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Table List Error", MB_OK)
		return OP_ERROR
	end if
	tables = db_table_list()
	return tables
end function

global function DB_Compress(sequence db)
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Compress Error", MB_OK)
		return OP_ERROR
	end if
	if db_compress() != DB_OK then
    	void =message_box("Error Compressing Database " & db, "Compress Error", MB_OK)
		return OP_ERROR
	end if
	return OP_OK
end function

global function DB_Create(sequence name, integer mode)
	if db_create(name, mode) != DB_OK then
    	void =message_box("Error Creating Database " & name, "Create Database Error", MB_OK)
		return OP_ERROR	
    end if
	return OP_OK
end function

global function DB_Table(sequence db, sequence tname, integer oper)
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Create Table Error", MB_OK)
		return OP_ERROR
	end if
	if oper = 1 then
		if db_create_table(tname) != DB_OK then
    		void =message_box("Error Creating Table " & db & "->" & tname, "Create Table Error", MB_OK)
		end if
	elsif oper = 0 then
			db_delete_table(tname)
	end if
	return OP_OK
end function

global function DB_Print(sequence db, sequence dumpto, integer mode, sequence openmode)
integer fn
	if db_select(db) != DB_OK then
    	void =message_box("Error Selecting Database " & db, "Print Database Error", MB_OK)
		return OP_ERROR
	end if
	fn = open(dumpto, openmode)
	if fn = -1 then
		void =message_box("Error Opening " & dumpto, "Print Database Error", MB_OK)
		return OP_ERROR
	end if
	db_dump(fn, mode)
	return OP_OK
end function

global function DB_Err_Handler(sequence routine)
	db_fatal_id = routine_id(routine)
	if db_fatal_id = -1 then
		return OP_ERROR
	end if
	return OP_OK
end function

